; OPT_Res	0	   ; RichMasm assumes this code needs no resources - delete if rsrc.rc is needed
;==============================================================================
    include \masm32\include\masm32rt.inc
    .686
    include \masm32\macros\timers.asm
    include \masm32\macros\ucmacros.asm
    include \masm32\include\shlwapi.inc
    includelib \masm32\lib\shlwapi.lib

InstrCiW	PROTO: DWORD, :DWORD, :DWORD

;==============================================================================
    .data
        ;             0123456789
        WSTR first,  "my other brother darryl"
        WSTR search, "BROTHER"
        ;             0123456789
        firsta  db   "my other brother darryl",0
        searcha db   "BROTHER",0
    .code
;==============================================================================
start:
;==============================================================================
    invoke crt_printf, cfm$("%S\n"), ADDR first
    invoke crt_printf, cfm$("%S\n"), ADDR search
    invoke crt_printf, cfm$("%s\n"), ADDR firsta
    invoke crt_printf, cfm$("%s\n\n"), ADDR searcha

    invoke StrStrIW, ADDR first, ADDR search
    sub eax, OFFSET first
    print str$(eax),13,10

    invoke StrStrIA, ADDR firsta, ADDR searcha
    sub eax, OFFSET firsta
    print str$(eax),13,10

    invoke InstrCiW, 1, ADDR first, ADDR search
    sub eax, OFFSET first
    print str$(eax),13,10

    invoke crt__wcslwr, ADDR first
    invoke crt__wcslwr, ADDR search
    invoke crt_wcsstr, ADDR first, ADDR search
    sub eax, OFFSET first
    print str$(eax),13,10,13,10

	push 1
	call ShowCpu	; print brand string and SSE level

    invoke Sleep, 1000

    counter_begin 1000, HIGH_PRIORITY_CLASS
      invoke StrStrIW, ADDR first, ADDR search
    counter_end
    print str$(eax), 9, " for StrStrIW", 13,10

    counter_begin 1000, HIGH_PRIORITY_CLASS
      invoke StrStrIA, ADDR firsta, ADDR searcha
    counter_end
    print str$(eax), 9, " for StrStrIA", 13,10

    counter_begin 1000, HIGH_PRIORITY_CLASS
      invoke InstrCiW, 1, ADDR first, ADDR search
    counter_end
    print str$(eax), 9, " for InstrCiW", 13,10

    counter_begin 1000, HIGH_PRIORITY_CLASS
      invoke crt__wcslwr, ADDR first
      invoke crt__wcslwr, ADDR search
      invoke crt_wcsstr, ADDR first, ADDR search
    counter_end
    print str$(eax), 9, " for wcsstr", 13,10,13,10

	mov eax, InstrCiW_E
	sub eax, InstrCiW_S
	print str$(eax), " bytes", 13, 10, 10

    inkey "Press any key to exit..."
    exit
InstrCiW_S:
InstrCiW proc uses edi esi ebx ecx StartPos:DWORD, lpSource:DWORD, lpPattern:DWORD
  mov esi, lpSource
  mov edi, lpPattern	; address of pattern
  movzx ebx, word ptr [edi]	; get first char of pattern
  or ebx, 00000020h	; lowercase
  push ebp		; no locals...
L1:	xor edx, edx
	mov dh, bl
	xor ebp, ebp
	or ecx, -1
@@:
	if 1
	lodsd	; lodsd is 4 bytes shorter, but might be slower
	else
	mov eax, [esi]	; get two chars
	add esi, 4
	endif
	test ax, ax	; if null, it's End Of String
	je EOS
	or eax, 00000020h	; to lowercase
	cmp ax, bx
	je L2	; don't inc ecx
	bswap eax
	test ax, ax
	je EOS
	or eax, 00002000h	; to lowercase
	cmp ax, dx
	jne @B
@@:	inc ecx
L2:	inc ebp
	movzx eax, word ptr [esi+2*ecx]	; second or third char of source against second char of pattern
	or eax, 00000020h
	movzx edx, word ptr [edi+2*ebp]
	test edx, edx
	je @F
	or edx, 00000020h
;	deb 1, "Mist", eax, edx
	cmp eax, edx
	je @B
	jmp L1
EOS:	xor eax, eax
	jmp NoSucc
@@:	sub ecx, ebp
	lea eax, [esi+2*ecx]
NoSucc:	pop ebp
	ret
InstrCiW endp
InstrCiW_E:

ShowCpu proc		; mode:DWORD
COMMENT @ Usage: 
  push 0, call ShowCpu	; simple, no printing, just returns SSE level
  push 1, call ShowCpu	; prints the brand string and returns SSE level@
  pushad
  sub esp, 80	; create a buffer for the brand string
  mov edi, esp		; point edi to it
  xor ebp, ebp
  .Repeat
  	lea eax, [ebp+80000002h]
	db 0Fh, 0A2h		; cpuid 80000002h-80000004h
	stosd
	mov eax, ebx
	stosd
	mov eax, ecx
	stosd
	mov eax, edx
	stosd
	inc ebp
  .Until ebp>=3
  push 1
  pop eax
  db 0Fh, 0A2h			; cpuid 1
  xor ebx, ebx					; CpuSSE
  xor esi, esi					; add zero plus the carry flag
  bt edx, 25					; edx bit 25, SSE1
  adc ebx, esi
  bt edx, 26					; edx bit 26, SSE2
  adc ebx, esi
  bt ecx, esi					; ecx bit 0, SSE3
  adc ebx, esi
  bt ecx, 9						; ecx bit 9, SSE4
  adc ebx, esi
  dec dword ptr [esp+4+32+80]				; dec mode in stack
  .if Zero?
	mov edi, esp							; restore pointer to brand string
  	.Repeat				
		.Break .if byte ptr [edi]!=32	; mode was 1, so show a string but skip leading blanks
		inc edi
	.Until 0
	.if byte ptr [edi]<32
		print chr$("pre-P4")
	.else
		print edi								; CpuBrand
	.endif
	.if ebx
		print chr$(32, 40, "SSE")		; info on SSE level, 40=(
		print str$(ebx), 41, 13, 10		; 41=)
	.endif
  .endif
  add esp, 80				; discard brand buffer (after printing!)
  mov [esp+32-4], ebx		; move ebx into eax stack position - returns eax to main for further use
  ifdef MbBufferInit
	MbBufferInit
  endif
  popad
  ret 4
ShowCpu endp

;==============================================================================
end start
OPT_Tmp2Asm	1
OPT_Wait	0
